Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 26391)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 26392)
@@ -649,14 +649,13 @@
 
     /* Create default storage controllers */
-    QString ideCtrName = VBoxVMSettingsHD::tr("IDE Controller");
+    QString ctrName = VBoxVMSettingsHD::tr("Storage Controller");
     KStorageBus ideBus = KStorageBus_IDE;
 
-    // Add IDE controller
-    m_Machine.AddStorageController(ideCtrName, ideBus);
-
-    // Set IDE controller type
-    CStorageController ctr = m_Machine.GetStorageControllerByName(ideCtrName);
+    // Add storage controller
+    m_Machine.AddStorageController(ctrName, ideBus);
+
+    // Set storage controller type
+    CStorageController ctr = m_Machine.GetStorageControllerByName(ctrName);
     KStorageControllerType storageControllerType = type.GetRecommendedStorageController();
-
     ctr.SetControllerType(storageControllerType);
 
@@ -688,5 +687,5 @@
             if (!field("hardDiskId").toString().isNull())
             {
-                m.AttachDevice(ideCtrName, 0, 0, KDeviceType_HardDisk, field("hardDiskId").toString());
+                m.AttachDevice(ctrName, 0, 0, KDeviceType_HardDisk, field("hardDiskId").toString());
                 if (!m.isOk())
                     vboxProblem().cannotAttachDevice(this, m, VBoxDefs::MediumType_HardDisk,
@@ -695,5 +694,5 @@
 
             /* Attach empty CD/DVD ROM Device */
-            m.AttachDevice(ideCtrName, 1, 0, KDeviceType_DVD, QString(""));
+            m.AttachDevice(ctrName, 1, 0, KDeviceType_DVD, QString(""));
             if (!m.isOk())
                 vboxProblem().cannotAttachDevice(this, m, VBoxDefs::MediumType_DVD, QString(), ideBus, 1, 0);
Index: /trunk/src/VBox/Main/ConsoleImpl2.cpp
===================================================================
--- /trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 26391)
+++ /trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 26392)
@@ -114,18 +114,17 @@
 int DarwinSmcKey(char* aKey, uint32_t iKeySize)
 {
-    int rc;
-    /*
-     * Code based on Amit Singh SMC reading code sample in OS X Book, see
-     * http://osxbook.com/book/bonus/chapter7/tpmdrmmyth/
+    /*
+     * Method as described in Amit Singh's article:
+     *   http://osxbook.com/book/bonus/chapter7/tpmdrmmyth/
      */
     typedef struct {
         uint32_t   key;
-        uint8_t    __d0[22];
+        uint8_t    pad0[22];
         uint32_t   datasize;
-        uint8_t    __d1[10];
+        uint8_t    pad1[10];
         uint8_t    cmd;
-        uint32_t   __d2;
+        uint32_t   pad2;
         uint8_t    data[32];
-    } AppleSMCBuffer_t;
+    } AppleSMCBuffer;
 
 
@@ -141,9 +140,9 @@
     kern_return_t kr = IOServiceOpen(service, mach_task_self(), 0, &port);
     IOObjectRelease(service);
+
     if (kr != kIOReturnSuccess)
         return VERR_INTERNAL_ERROR;
 
-
-    AppleSMCBuffer_t inputStruct = { 0, {0}, 32, {0}, 5, }, outputStruct;
+    AppleSMCBuffer inputStruct = { 0, {0}, 32, {0}, 5, }, outputStruct;
     size_t outputStructCnt = sizeof(outputStruct);
 
@@ -428,5 +427,5 @@
         /** @todo This is currently only forced off on 32-bit hosts only because it
          *        makes a lof of difference there (REM and Solaris performance).
-         */        
+         */
         BOOL fSupportsLongMode = false;
         hrc = host->GetProcessorFeature(ProcessorFeature_LongMode,
Index: /trunk/src/VBox/Main/Global.cpp
===================================================================
--- /trunk/src/VBox/Main/Global.cpp	(revision 26391)
+++ /trunk/src/VBox/Main/Global.cpp	(revision 26392)
@@ -37,19 +37,19 @@
      *        '2GB' looks better than '1.95GB' (= 2000MB) */
     { "Other",   "Other",             SchemaDefs_OSTypeId_Other,           "Other/Unknown",
-      VBOXOSTYPE_Unknown,         VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Unknown,         VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_Windows31,       "Windows 3.1",
-      VBOXOSTYPE_Win31,           VBOXOSHINT_NONE,  32,   4,  1 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Win31,           VBOXOSHINT_NONE,  32,   4,  1 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_Windows95,       "Windows 95",
-      VBOXOSTYPE_Win95,           VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Win95,           VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_Windows98,       "Windows 98",
-      VBOXOSTYPE_Win98,           VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Win98,           VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_WindowsMe,       "Windows Me",
-      VBOXOSTYPE_WinMe,           VBOXOSHINT_NONE,  64,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_WinMe,           VBOXOSHINT_NONE,  64,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_WindowsNT4,      "Windows NT 4",
-      VBOXOSTYPE_WinNT4,          VBOXOSHINT_NONE, 128,  16,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_WinNT4,          VBOXOSHINT_NONE, 128,  16,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_Windows2000,     "Windows 2000",
-      VBOXOSTYPE_Win2k,           VBOXOSHINT_NONE, 168,  16,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Win2k,           VBOXOSHINT_NONE, 168,  16,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_WindowsXP,       "Windows XP",
-      VBOXOSTYPE_WinXP,           VBOXOSHINT_NONE, 192,  16, 10 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_WinXP,           VBOXOSHINT_NONE, 192,  16, 10 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_WindowsXP_64,    "Windows XP (64 bit)",
       VBOXOSTYPE_WinXP_x64,       VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  192,  16, 10 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
@@ -71,97 +71,97 @@
       VBOXOSTYPE_Win7_x64,        VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  512,  16, 20 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Windows", "Microsoft Windows", SchemaDefs_OSTypeId_WindowsNT,       "Other Windows",
-      VBOXOSTYPE_WinNT,           VBOXOSHINT_NONE, 512,  16, 20 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_WinNT,           VBOXOSHINT_NONE, 512,  16, 20 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux22,         "Linux 2.2",
-      VBOXOSTYPE_Linux22,         VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux22,         VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux24,         "Linux 2.4",
-      VBOXOSTYPE_Linux24,         VBOXOSHINT_NONE, 128,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux24,         VBOXOSHINT_NONE, 128,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux24_64,      "Linux 2.4 (64 bit)",
-      VBOXOSTYPE_Linux24_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  128,   4,  4 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux24_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  128,   4,  4 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux26,         "Linux 2.6",
-      VBOXOSTYPE_Linux26,         VBOXOSHINT_NONE, 256,   4,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux26,         VBOXOSHINT_NONE, 256,   4,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux26_64,      "Linux 2.6 (64 bit)",
-      VBOXOSTYPE_Linux26_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,   4,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux26_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,   4,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_ArchLinux,       "Arch Linux",
-      VBOXOSTYPE_ArchLinux,       VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_ArchLinux,       VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_ArchLinux_64,    "Arch Linux (64 bit)",
-      VBOXOSTYPE_ArchLinux_x64,   VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_ArchLinux_x64,   VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Debian,          "Debian",
-      VBOXOSTYPE_Debian,          VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Debian,          VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Debian_64,       "Debian (64 bit)",
-      VBOXOSTYPE_Debian_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Debian_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_OpenSUSE,        "openSUSE",
-      VBOXOSTYPE_OpenSUSE,        VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenSUSE,        VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_OpenSUSE_64,     "openSUSE (64 bit)",
-      VBOXOSTYPE_OpenSUSE_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenSUSE_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Fedora,          "Fedora",
-      VBOXOSTYPE_FedoraCore,      VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_FedoraCore,      VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Fedora_64,       "Fedora (64 bit)",
-      VBOXOSTYPE_FedoraCore_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_FedoraCore_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Gentoo,          "Gentoo",
-      VBOXOSTYPE_Gentoo,          VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Gentoo,          VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Gentoo_64,       "Gentoo (64 bit)",
-      VBOXOSTYPE_Gentoo_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Gentoo_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Mandriva,        "Mandriva",
-      VBOXOSTYPE_Mandriva,        VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Mandriva,        VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Mandriva_64,     "Mandriva (64 bit)",
-      VBOXOSTYPE_Mandriva_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Mandriva_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_RedHat,          "Red Hat",
-      VBOXOSTYPE_RedHat,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_RedHat,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_RedHat_64,       "Red Hat (64 bit)",
-      VBOXOSTYPE_RedHat_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_RedHat_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Turbolinux,      "Turbolinux",
-      VBOXOSTYPE_Turbolinux,      VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Turbolinux,      VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Ubuntu,          "Ubuntu",
-      VBOXOSTYPE_Ubuntu,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Ubuntu,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Ubuntu_64,       "Ubuntu (64 bit)",
-      VBOXOSTYPE_Ubuntu_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Ubuntu_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Xandros,         "Xandros",
-      VBOXOSTYPE_Xandros,         VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Xandros,         VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Xandros_64,      "Xandros (64 bit)",
-      VBOXOSTYPE_Xandros_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Xandros_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Oracle,          "Oracle",
-      VBOXOSTYPE_Oracle,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Oracle,          VBOXOSHINT_NONE, 384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Oracle_64,       "Oracle (64 bit)",
-      VBOXOSTYPE_Oracle_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Oracle_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux,           "Other Linux",
-      VBOXOSTYPE_Linux,           VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Linux,           VBOXOSHINT_NONE, 256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Solaris", "Solaris",           SchemaDefs_OSTypeId_Solaris,         "Solaris",
-      VBOXOSTYPE_Solaris,         VBOXOSHINT_NONE, 768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Solaris,         VBOXOSHINT_NONE, 768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Solaris", "Solaris",           SchemaDefs_OSTypeId_Solaris_64,      "Solaris (64 bit)",
-      VBOXOSTYPE_Solaris_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Solaris_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Solaris", "Solaris",           SchemaDefs_OSTypeId_OpenSolaris,     "OpenSolaris",
-      VBOXOSTYPE_OpenSolaris,     VBOXOSHINT_NONE, 768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenSolaris,     VBOXOSHINT_NONE, 768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Solaris", "Solaris",           SchemaDefs_OSTypeId_OpenSolaris_64,  "OpenSolaris (64 bit)",
-      VBOXOSTYPE_OpenSolaris_x64, VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenSolaris_x64, VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  768,  12, 16 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_FreeBSD,         "FreeBSD",
-      VBOXOSTYPE_FreeBSD,         VBOXOSHINT_NONE, 128,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_FreeBSD,         VBOXOSHINT_NONE, 128,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_FreeBSD_64,      "FreeBSD (64 bit)",
-      VBOXOSTYPE_FreeBSD_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  128,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_FreeBSD_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,  128,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_OpenBSD,         "OpenBSD",
-      VBOXOSTYPE_OpenBSD,         VBOXOSHINT_HWVIRTEX,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenBSD,         VBOXOSHINT_HWVIRTEX,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_OpenBSD_64,      "OpenBSD (64 bit)",
-      VBOXOSTYPE_OpenBSD_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,   64,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OpenBSD_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,   64,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_NetBSD,          "NetBSD",
-      VBOXOSTYPE_NetBSD,          VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_NetBSD,          VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "BSD",     "BSD",               SchemaDefs_OSTypeId_NetBSD_64,       "NetBSD (64 bit)",
-      VBOXOSTYPE_NetBSD_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,   64,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_NetBSD_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC,   64,   4,  2 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "OS2",     "IBM OS/2",          SchemaDefs_OSTypeId_OS2Warp3,        "OS/2 Warp 3",
-      VBOXOSTYPE_OS2Warp3,        VBOXOSHINT_HWVIRTEX,   48,   4,  1 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OS2Warp3,        VBOXOSHINT_HWVIRTEX,   48,   4,  1 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX4 },
     { "OS2",     "IBM OS/2",          SchemaDefs_OSTypeId_OS2Warp4,        "OS/2 Warp 4",
-      VBOXOSTYPE_OS2Warp4,        VBOXOSHINT_HWVIRTEX,   64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OS2Warp4,        VBOXOSHINT_HWVIRTEX,   64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX4 },
     { "OS2",     "IBM OS/2",          SchemaDefs_OSTypeId_OS2Warp45,       "OS/2 Warp 4.5",
-      VBOXOSTYPE_OS2Warp45,       VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OS2Warp45,       VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX4 },
     { "OS2",     "IBM OS/2",          SchemaDefs_OSTypeId_OS2eCS,          "eComStation",
-      VBOXOSTYPE_ECS,             VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_ECS,             VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX4 },
     { "OS2",     "IBM OS/2",          SchemaDefs_OSTypeId_OS2,             "Other OS/2",
-      VBOXOSTYPE_OS2,             VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_OS2,             VBOXOSHINT_HWVIRTEX,   96,   4,  2 * _1K, NetworkAdapterType_Am79C973, 1, StorageControllerType_PIIX4 },
     { "Other",   "Other",             SchemaDefs_OSTypeId_DOS,             "DOS",
-      VBOXOSTYPE_DOS,             VBOXOSHINT_NONE,  32,   4,      512, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_DOS,             VBOXOSHINT_NONE,  32,   4,      512, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Other",   "Other",             SchemaDefs_OSTypeId_Netware,         "Netware",
-      VBOXOSTYPE_Netware,         VBOXOSHINT_HWVIRTEX, 512,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_Netware,         VBOXOSHINT_HWVIRTEX, 512,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Other",   "Other",             SchemaDefs_OSTypeId_L4,              "L4",
-      VBOXOSTYPE_L4,              VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_L4,              VBOXOSHINT_NONE,  64,   4,  2 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Other",   "Other",             SchemaDefs_OSTypeId_QNX,             "QNX",
-      VBOXOSTYPE_QNX,             VBOXOSHINT_HWVIRTEX,  512,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX3 },
+      VBOXOSTYPE_QNX,             VBOXOSHINT_HWVIRTEX,  512,   4,  4 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "MacOS",  "Mac OS X",             SchemaDefs_OSTypeId_MacOS,             "Mac OS X",
       VBOXOSTYPE_MacOS,           VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_EFI | VBOXOSHINT_PAE,  1024,   4,  20 * _1K, NetworkAdapterType_I82543GC, 0, StorageControllerType_ICH6 },