Index: trunk/include/VBox/HGSMI/HGSMIChannels.h
===================================================================
--- trunk/include/VBox/HGSMI/HGSMIChannels.h	(revision 26471)
+++ trunk/include/VBox/HGSMI/HGSMIChannels.h	(revision 26487)
@@ -42,5 +42,5 @@
  * to a free 16 bit numerical value. values are allocated in range
  * [HGSMI_CH_STRING_FIRST;HGSMI_CH_STRING_LAST].
- * 
+ *
  */
 
Index: trunk/include/VBox/HostServices/VBoxOGLOp.h
===================================================================
--- trunk/include/VBox/HostServices/VBoxOGLOp.h	(revision 26471)
+++ trunk/include/VBox/HostServices/VBoxOGLOp.h	(revision 26487)
@@ -56,5 +56,5 @@
     OGL_CMD(op, 0, 0);                                                                      \
     OGL_CMD_END(op);
-    
+
 #define VBOX_OGL_GEN_OP1(op, p1)                                                            \
     OGL_CMD(op, 1, sizeof(p1));                                                             \
@@ -576,5 +576,5 @@
     OGL_CMD(op, 0);                                                                         \
     gl##op();
-    
+
 #define VBOX_OGL_GEN_OP1(op, Type1)                                                         \
     OGL_CMD(op, 1);                                                                         \
@@ -767,5 +767,5 @@
     OGL_PARAM(Type1, p1);                                                                       \
     pClient->lastretval = gl##op(p1);
-    
+
 #define VBOX_OGL_GEN_SYNC_OP2_RET(rettype, op, Type1, Type2)                                          \
     OGL_CMD(op, 2);                                                                             \
@@ -1016,5 +1016,5 @@
 /* OpenGL opcodes */
 /* Note: keep all three tables in sync! */
-typedef enum 
+typedef enum
 {
     VBOX_OGL_OP_Illegal                     = 0,
@@ -1891,5 +1891,5 @@
 #endif
 
-static OPENGL_EXT OpenGLExtensions[] = 
+static OPENGL_EXT OpenGLExtensions[] =
 {
     {   "WGL_EXT_swap_control",             "wglSwapIntervalEXT",               VBOX_OGL_EXTENSION(wglSwapIntervalEXT),                      false },
Index: trunk/include/VBox/HostServices/VBoxOpenGLSvc.h
===================================================================
--- trunk/include/VBox/HostServices/VBoxOpenGLSvc.h	(revision 26471)
+++ trunk/include/VBox/HostServices/VBoxOpenGLSvc.h	(revision 26487)
@@ -125,5 +125,5 @@
      */
     HGCMFunctionParameter   cCommands;
-    
+
     /** 64bit, out: retval
      * uint64_t return code of last command
@@ -164,5 +164,5 @@
      */
     HGCMFunctionParameter   pLastParam;
-    
+
     /** 64bit, out: retval
      * uint64_t return code of last command
Index: trunk/include/VBox/cpumdis.h
===================================================================
--- trunk/include/VBox/cpumdis.h	(revision 26471)
+++ trunk/include/VBox/cpumdis.h	(revision 26487)
@@ -62,6 +62,2 @@
 #endif
 
-
-
-
-
Index: trunk/include/VBox/pdmqueue.h
===================================================================
--- trunk/include/VBox/pdmqueue.h	(revision 26471)
+++ trunk/include/VBox/pdmqueue.h	(revision 26487)
@@ -150,3 +150,2 @@
 #endif
 
-
Index: trunk/include/VBox/vmapi.h
===================================================================
--- trunk/include/VBox/vmapi.h	(revision 26471)
+++ trunk/include/VBox/vmapi.h	(revision 26487)
@@ -429,3 +429,2 @@
 #endif
 
-
Index: trunk/include/VBox/vrdpapi.h
===================================================================
--- trunk/include/VBox/vrdpapi.h	(revision 26471)
+++ trunk/include/VBox/vrdpapi.h	(revision 26487)
@@ -1018,5 +1018,5 @@
     /**
      * Query or set various information, on how the VRDP server operates, from or to the application.
-     * 
+     *
      *
      * @param pvCallback  The callback specific pointer.
Index: trunk/include/VBox/vusb.h
===================================================================
--- trunk/include/VBox/vusb.h	(revision 26471)
+++ trunk/include/VBox/vusb.h	(revision 26487)
@@ -287,5 +287,5 @@
 #define VUSB_DIR_TO_DEVICE      0x00
 #define VUSB_DIR_TO_HOST        0x80
-#define	VUSB_DIR_MASK           0x80
+#define VUSB_DIR_MASK           0x80
 
 /**